const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscribersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscribers = await db.subscribers.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        org: data.org || null,
        email: data.email || null,
        role: data.role || null,
        status: data.status || null,
        last_login: data.last_login || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await subscribers.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await subscribers.setOrganizations(data.organizations || null, {
      transaction,
    });

    return subscribers;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const subscribersData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      org: item.org || null,
      email: item.email || null,
      role: item.role || null,
      status: item.status || null,
      last_login: item.last_login || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const subscribers = await db.subscribers.bulkCreate(subscribersData, {
      transaction,
    });

    // For each item created, replace relation files

    return subscribers;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const subscribers = await db.subscribers.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.org !== undefined) updatePayload.org = data.org;

    if (data.email !== undefined) updatePayload.email = data.email;

    if (data.role !== undefined) updatePayload.role = data.role;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.last_login !== undefined)
      updatePayload.last_login = data.last_login;

    updatePayload.updatedById = currentUser.id;

    await subscribers.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await subscribers.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await subscribers.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return subscribers;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscribers = await db.subscribers.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of subscribers) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of subscribers) {
        await record.destroy({ transaction });
      }
    });

    return subscribers;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscribers = await db.subscribers.findByPk(id, options);

    await subscribers.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await subscribers.destroy({
      transaction,
    });

    return subscribers;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const subscribers = await db.subscribers.findOne(
      { where },
      { transaction },
    );

    if (!subscribers) {
      return subscribers;
    }

    const output = subscribers.get({ plain: true });

    output.patient_profiles_subscriber =
      await subscribers.getPatient_profiles_subscriber({
        transaction,
      });

    output.subscriber_activities_subscriber =
      await subscribers.getSubscriber_activities_subscriber({
        transaction,
      });

    output.subscriber_roles_subscriber =
      await subscribers.getSubscriber_roles_subscriber({
        transaction,
      });

    output.organization = await subscribers.getOrganization({
      transaction,
    });

    output.organizations = await subscribers.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('subscribers', 'name', filter.name),
        };
      }

      if (filter.org) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('subscribers', 'org', filter.org),
        };
      }

      if (filter.email) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('subscribers', 'email', filter.email),
        };
      }

      if (filter.last_loginRange) {
        const [start, end] = filter.last_loginRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            last_login: {
              ...where.last_login,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            last_login: {
              ...where.last_login,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.role) {
        where = {
          ...where,
          role: filter.role,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.subscribers.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('subscribers', 'name', query),
        ],
      };
    }

    const records = await db.subscribers.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
